function CCWatch_Config()

CCWATCH.CCS = {}

-- required attributes: GROUP, LENGTH, DIMINISHES
--  GROUP = Bar this CC is placed on
--  LENGTH = Duration of CC
--  DIMINISHES = 0 never diminishes, 1 = always diminishes, 2 = diminishes on players only
-- optional attributes PVPCC, COMBO
--  PVPCC = if PVPCC exists this value will be used as the base max for a Player target
--  COMBO = if COMBO exists then Combo Points will be added to CC duration
--
-- TARGET, PLAYER, TIMER_START, TIMER_END, DIMINISH are required for all and should be initialized empty
-- MONITOR is required for all and should be initialized to true
-- Rogue
CCWATCH.CCS[CCWATCH_GOUGE] = {}
CCWATCH.CCS[CCWATCH_GOUGE].GROUP = 2
CCWATCH.CCS[CCWATCH_GOUGE].LENGTH = 5.5
CCWATCH.CCS[CCWATCH_GOUGE].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_GOUGE].TARGET = ""
CCWATCH.CCS[CCWATCH_GOUGE].PLAYER = nil
CCWATCH.CCS[CCWATCH_GOUGE].TIMER_START = 0
CCWATCH.CCS[CCWATCH_GOUGE].TIMER_END = 0
CCWATCH.CCS[CCWATCH_GOUGE].DIMINISH = 1
CCWATCH.CCS[CCWATCH_GOUGE].MONITOR = true


CCWATCH.CCS[CCWATCH_BLIND] = {}
CCWATCH.CCS[CCWATCH_BLIND].GROUP = 2
CCWATCH.CCS[CCWATCH_BLIND].LENGTH = 10
CCWATCH.CCS[CCWATCH_BLIND].DIMINISHES = 1

CCWATCH.CCS[CCWATCH_BLIND].TARGET = ""
CCWATCH.CCS[CCWATCH_BLIND].PLAYER = nil
CCWATCH.CCS[CCWATCH_BLIND].TIMER_START = 0
CCWATCH.CCS[CCWATCH_BLIND].TIMER_END = 0
CCWATCH.CCS[CCWATCH_BLIND].DIMINISH = 1
CCWATCH.CCS[CCWATCH_BLIND].MONITOR = true


CCWATCH.CCS[CCWATCH_SAP] = {}
CCWATCH.CCS[CCWATCH_SAP].GROUP = 3
CCWATCH.CCS[CCWATCH_SAP].LENGTH = 45
CCWATCH.CCS[CCWATCH_SAP].PVPCC = 15
CCWATCH.CCS[CCWATCH_SAP].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_SAP].TARGET = ""
CCWATCH.CCS[CCWATCH_SAP].PLAYER = nil
CCWATCH.CCS[CCWATCH_SAP].TIMER_START = 0
CCWATCH.CCS[CCWATCH_SAP].TIMER_END = 0
CCWATCH.CCS[CCWATCH_SAP].DIMINISH = 1
CCWATCH.CCS[CCWATCH_SAP].MONITOR = true


CCWATCH.CCS[CCWATCH_KS] = {}
CCWATCH.CCS[CCWATCH_KS].GROUP = 1
CCWATCH.CCS[CCWATCH_KS].LENGTH = 1
CCWATCH.CCS[CCWATCH_KS].COMBO = true
CCWATCH.CCS[CCWATCH_KS].DIMINISHES = 1

CCWATCH.CCS[CCWATCH_KS].TARGET = ""
CCWATCH.CCS[CCWATCH_KS].PLAYER = nil
CCWATCH.CCS[CCWATCH_KS].TIMER_START = 0
CCWATCH.CCS[CCWATCH_KS].TIMER_END = 0
CCWATCH.CCS[CCWATCH_KS].DIMINISH = 1
CCWATCH.CCS[CCWATCH_KS].MONITOR = true


CCWATCH.CCS[CCWATCH_CS] = {}
CCWATCH.CCS[CCWATCH_CS].GROUP = 1
CCWATCH.CCS[CCWATCH_CS].LENGTH = 4
CCWATCH.CCS[CCWATCH_CS].DIMINISHES = 1

CCWATCH.CCS[CCWATCH_CS].TARGET = ""
CCWATCH.CCS[CCWATCH_CS].PLAYER = nil
CCWATCH.CCS[CCWATCH_CS].TIMER_START = 0
CCWATCH.CCS[CCWATCH_CS].TIMER_END = 0
CCWATCH.CCS[CCWATCH_CS].DIMINISH = 1
CCWATCH.CCS[CCWATCH_CS].MONITOR = true


-- Priest
CCWATCH.CCS[CCWATCH_SHACKLE] = {}
CCWATCH.CCS[CCWATCH_SHACKLE].GROUP = 4
CCWATCH.CCS[CCWATCH_SHACKLE].LENGTH = 30
 -- 40 50
CCWATCH.CCS[CCWATCH_SHACKLE].DIMINISHES = 0

CCWATCH.CCS[CCWATCH_SHACKLE].TARGET = ""
CCWATCH.CCS[CCWATCH_SHACKLE].PLAYER = nil
CCWATCH.CCS[CCWATCH_SHACKLE].TIMER_START = 0
CCWATCH.CCS[CCWATCH_SHACKLE].TIMER_END = 0
CCWATCH.CCS[CCWATCH_SHACKLE].DIMINISH = 0
CCWATCH.CCS[CCWATCH_SHACKLE].MONITOR = true


CCWATCH.CCS[CCWATCH_PSYCHICSCREAM] = {}
CCWATCH.CCS[CCWATCH_PSYCHICSCREAM].GROUP = 2
CCWATCH.CCS[CCWATCH_PSYCHICSCREAM].LENGTH = 8
CCWATCH.CCS[CCWATCH_PSYCHICSCREAM].DIMINISHES = 0

CCWATCH.CCS[CCWATCH_PSYCHICSCREAM].TARGET = ""
CCWATCH.CCS[CCWATCH_PSYCHICSCREAM].PLAYER = nil
CCWATCH.CCS[CCWATCH_PSYCHICSCREAM].TIMER_START = 0
CCWATCH.CCS[CCWATCH_PSYCHICSCREAM].TIMER_END = 0
CCWATCH.CCS[CCWATCH_PSYCHICSCREAM].DIMINISH = 0
CCWATCH.CCS[CCWATCH_PSYCHICSCREAM].MONITOR = true


CCWATCH.CCS[CCWATCH_BLACKOUT] = {}
CCWATCH.CCS[CCWATCH_BLACKOUT].GROUP = 1
CCWATCH.CCS[CCWATCH_BLACKOUT].LENGTH = 2
CCWATCH.CCS[CCWATCH_BLACKOUT].DIMINISHES = 0

CCWATCH.CCS[CCWATCH_BLACKOUT].TARGET = ""
CCWATCH.CCS[CCWATCH_BLACKOUT].PLAYER = nil
CCWATCH.CCS[CCWATCH_BLACKOUT].TIMER_START = 0
CCWATCH.CCS[CCWATCH_BLACKOUT].TIMER_END = 0
CCWATCH.CCS[CCWATCH_BLACKOUT].DIMINISH = 0
CCWATCH.CCS[CCWATCH_BLACKOUT].MONITOR = true


-- Mage
CCWATCH.CCS[CCWATCH_POLYMORPH] = {}
CCWATCH.CCS[CCWATCH_POLYMORPH].GROUP = 4
CCWATCH.CCS[CCWATCH_POLYMORPH].LENGTH = 20
 -- 30 40 50
CCWATCH.CCS[CCWATCH_POLYMORPH].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_POLYMORPH].TARGET = ""
CCWATCH.CCS[CCWATCH_POLYMORPH].PLAYER = nil
CCWATCH.CCS[CCWATCH_POLYMORPH].TIMER_START = 0
CCWATCH.CCS[CCWATCH_POLYMORPH].TIMER_END = 0
CCWATCH.CCS[CCWATCH_POLYMORPH].DIMINISH = 1
CCWATCH.CCS[CCWATCH_POLYMORPH].MONITOR = true


CCWATCH.CCS[CCWATCH_FROSTNOVA] = {}
CCWATCH.CCS[CCWATCH_FROSTNOVA].GROUP = 1
CCWATCH.CCS[CCWATCH_FROSTNOVA].LENGTH = 8
CCWATCH.CCS[CCWATCH_FROSTNOVA].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_FROSTNOVA].TARGET = ""
CCWATCH.CCS[CCWATCH_FROSTNOVA].PLAYER = nil
CCWATCH.CCS[CCWATCH_FROSTNOVA].TIMER_START = 0
CCWATCH.CCS[CCWATCH_FROSTNOVA].TIMER_END = 0
CCWATCH.CCS[CCWATCH_FROSTNOVA].DIMINISH = 1
CCWATCH.CCS[CCWATCH_FROSTNOVA].MONITOR = true


CCWATCH.CCS[CCWATCH_FROSTBITE] = {}
CCWATCH.CCS[CCWATCH_FROSTBITE].GROUP = 2
CCWATCH.CCS[CCWATCH_FROSTBITE].LENGTH = 5
CCWATCH.CCS[CCWATCH_FROSTBITE].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_FROSTBITE].TARGET = ""
CCWATCH.CCS[CCWATCH_FROSTBITE].PLAYER = nil
CCWATCH.CCS[CCWATCH_FROSTBITE].TIMER_START = 0
CCWATCH.CCS[CCWATCH_FROSTBITE].TIMER_END = 0
CCWATCH.CCS[CCWATCH_FROSTBITE].DIMINISH = 1
CCWATCH.CCS[CCWATCH_FROSTBITE].MONITOR = true


CCWATCH.CCS[CCWATCH_ICEBLOCK] = {}
CCWATCH.CCS[CCWATCH_ICEBLOCK].GROUP = 3
CCWATCH.CCS[CCWATCH_ICEBLOCK].LENGTH = 10
CCWATCH.CCS[CCWATCH_ICEBLOCK].DIMINISHES = 0

CCWATCH.CCS[CCWATCH_ICEBLOCK].TARGET = ""
CCWATCH.CCS[CCWATCH_ICEBLOCK].PLAYER = nil
CCWATCH.CCS[CCWATCH_ICEBLOCK].TIMER_START = 0
CCWATCH.CCS[CCWATCH_ICEBLOCK].TIMER_END = 0
CCWATCH.CCS[CCWATCH_ICEBLOCK].DIMINISH = 1
CCWATCH.CCS[CCWATCH_ICEBLOCK].MONITOR = true

-- Druid
CCWATCH.CCS[CCWATCH_ROOTS] = {}
CCWATCH.CCS[CCWATCH_ROOTS].GROUP = 1
CCWATCH.CCS[CCWATCH_ROOTS].LENGTH = 12
-- 15 18 21 24 27
CCWATCH.CCS[CCWATCH_ROOTS].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_ROOTS].TARGET = ""
CCWATCH.CCS[CCWATCH_ROOTS].PLAYER = nil
CCWATCH.CCS[CCWATCH_ROOTS].TIMER_START = 0
CCWATCH.CCS[CCWATCH_ROOTS].TIMER_END = 0
CCWATCH.CCS[CCWATCH_ROOTS].DIMINISH = 1
CCWATCH.CCS[CCWATCH_ROOTS].MONITOR = true


CCWATCH.CCS[CCWATCH_HIBERNATE] = {}
CCWATCH.CCS[CCWATCH_HIBERNATE].GROUP = 4
CCWATCH.CCS[CCWATCH_HIBERNATE].LENGTH = 20
-- 30 40
CCWATCH.CCS[CCWATCH_HIBERNATE].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_HIBERNATE].TARGET = ""
CCWATCH.CCS[CCWATCH_HIBERNATE].PLAYER = nil
CCWATCH.CCS[CCWATCH_HIBERNATE].TIMER_START = 0
CCWATCH.CCS[CCWATCH_HIBERNATE].TIMER_END = 0
CCWATCH.CCS[CCWATCH_HIBERNATE].DIMINISH = 1
CCWATCH.CCS[CCWATCH_HIBERNATE].MONITOR = true


CCWATCH.CCS[CCWATCH_FERALCHARGE] = {}
CCWATCH.CCS[CCWATCH_FERALCHARGE].GROUP = 2
CCWATCH.CCS[CCWATCH_FERALCHARGE].LENGTH = 4
CCWATCH.CCS[CCWATCH_FERALCHARGE].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_FERALCHARGE].TARGET = ""
CCWATCH.CCS[CCWATCH_FERALCHARGE].PLAYER = nil
CCWATCH.CCS[CCWATCH_FERALCHARGE].TIMER_START = 0
CCWATCH.CCS[CCWATCH_FERALCHARGE].TIMER_END = 0
CCWATCH.CCS[CCWATCH_FERALCHARGE].DIMINISH = 1
CCWATCH.CCS[CCWATCH_FERALCHARGE].MONITOR = true


CCWATCH.CCS[CCWATCH_IMPSTARFIRE] = {}
CCWATCH.CCS[CCWATCH_IMPSTARFIRE].GROUP = 2
CCWATCH.CCS[CCWATCH_IMPSTARFIRE].LENGTH = 3
CCWATCH.CCS[CCWATCH_IMPSTARFIRE].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_IMPSTARFIRE].TARGET = ""
CCWATCH.CCS[CCWATCH_IMPSTARFIRE].PLAYER = nil
CCWATCH.CCS[CCWATCH_IMPSTARFIRE].TIMER_START = 0
CCWATCH.CCS[CCWATCH_IMPSTARFIRE].TIMER_END = 0
CCWATCH.CCS[CCWATCH_IMPSTARFIRE].DIMINISH = 1
CCWATCH.CCS[CCWATCH_IMPSTARFIRE].MONITOR = true


CCWATCH.CCS[CCWATCH_POUNCE] = {}
CCWATCH.CCS[CCWATCH_POUNCE].GROUP = 1
CCWATCH.CCS[CCWATCH_POUNCE].LENGTH = 2
CCWATCH.CCS[CCWATCH_POUNCE].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_POUNCE].TARGET = ""
CCWATCH.CCS[CCWATCH_POUNCE].PLAYER = nil
CCWATCH.CCS[CCWATCH_POUNCE].TIMER_START = 0
CCWATCH.CCS[CCWATCH_POUNCE].TIMER_END = 0
CCWATCH.CCS[CCWATCH_POUNCE].DIMINISH = 1
CCWATCH.CCS[CCWATCH_POUNCE].MONITOR = true


CCWATCH.CCS[CCWATCH_BASH] = {}
CCWATCH.CCS[CCWATCH_BASH].GROUP = 1
CCWATCH.CCS[CCWATCH_BASH].LENGTH = 2
CCWATCH.CCS[CCWATCH_BASH].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_BASH].TARGET = ""
CCWATCH.CCS[CCWATCH_BASH].PLAYER = nil
CCWATCH.CCS[CCWATCH_BASH].TIMER_START = 0
CCWATCH.CCS[CCWATCH_BASH].TIMER_END = 0
CCWATCH.CCS[CCWATCH_BASH].DIMINISH = 1
CCWATCH.CCS[CCWATCH_BASH].MONITOR = true


-- Hunter
CCWATCH.CCS[CCWATCH_FREEZINGTRAP] = {}
CCWATCH.CCS[CCWATCH_FREEZINGTRAP].GROUP = 3
CCWATCH.CCS[CCWATCH_FREEZINGTRAP].LENGTH = 10
-- 15 20
CCWATCH.CCS[CCWATCH_FREEZINGTRAP].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_FREEZINGTRAP].TARGET = ""
CCWATCH.CCS[CCWATCH_FREEZINGTRAP].PLAYER = nil
CCWATCH.CCS[CCWATCH_FREEZINGTRAP].TIMER_START = 0
CCWATCH.CCS[CCWATCH_FREEZINGTRAP].TIMER_END = 0
CCWATCH.CCS[CCWATCH_FREEZINGTRAP].DIMINISH = 1
CCWATCH.CCS[CCWATCH_FREEZINGTRAP].MONITOR = true

CCWATCH.CCS[CCWATCH_IMPCS] = {}
CCWATCH.CCS[CCWATCH_IMPCS].GROUP = 2
CCWATCH.CCS[CCWATCH_IMPCS].LENGTH = 30
CCWATCH.CCS[CCWATCH_IMPCS].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_IMPCS].TARGET = ""
CCWATCH.CCS[CCWATCH_IMPCS].PLAYER = nil
CCWATCH.CCS[CCWATCH_IMPCS].TIMER_START = 0
CCWATCH.CCS[CCWATCH_IMPCS].TIMER_END = 0
CCWATCH.CCS[CCWATCH_IMPCS].DIMINISH = 1
CCWATCH.CCS[CCWATCH_IMPCS].MONITOR = true


CCWATCH.CCS[CCWATCH_SCAREBEAST] = {}
CCWATCH.CCS[CCWATCH_SCAREBEAST].GROUP = 3
CCWATCH.CCS[CCWATCH_SCAREBEAST].LENGTH = 10
-- 15 20
CCWATCH.CCS[CCWATCH_SCAREBEAST].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_SCAREBEAST].TARGET = ""
CCWATCH.CCS[CCWATCH_SCAREBEAST].PLAYER = nil
CCWATCH.CCS[CCWATCH_SCAREBEAST].TIMER_START = 0
CCWATCH.CCS[CCWATCH_SCAREBEAST].TIMER_END = 0
CCWATCH.CCS[CCWATCH_SCAREBEAST].DIMINISH = 1
CCWATCH.CCS[CCWATCH_SCAREBEAST].MONITOR = true


CCWATCH.CCS[CCWATCH_SCATTERSHOT] = {}
CCWATCH.CCS[CCWATCH_SCATTERSHOT].GROUP = 2
CCWATCH.CCS[CCWATCH_SCATTERSHOT].LENGTH = 4
-- 15 20
CCWATCH.CCS[CCWATCH_SCATTERSHOT].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_SCATTERSHOT].TARGET = ""
CCWATCH.CCS[CCWATCH_SCATTERSHOT].PLAYER = nil
CCWATCH.CCS[CCWATCH_SCATTERSHOT].TIMER_START = 0
CCWATCH.CCS[CCWATCH_SCATTERSHOT].TIMER_END = 0
CCWATCH.CCS[CCWATCH_SCATTERSHOT].DIMINISH = 1
CCWATCH.CCS[CCWATCH_SCATTERSHOT].MONITOR = true


CCWATCH.CCS[CCWATCH_INTIMIDATION] = {}
CCWATCH.CCS[CCWATCH_INTIMIDATION].GROUP = 2
CCWATCH.CCS[CCWATCH_INTIMIDATION].LENGTH = 3
-- 15 20
CCWATCH.CCS[CCWATCH_INTIMIDATION].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_INTIMIDATION].TARGET = ""
CCWATCH.CCS[CCWATCH_INTIMIDATION].PLAYER = nil
CCWATCH.CCS[CCWATCH_INTIMIDATION].TIMER_START = 0
CCWATCH.CCS[CCWATCH_INTIMIDATION].TIMER_END = 0
CCWATCH.CCS[CCWATCH_INTIMIDATION].DIMINISH = 1
CCWATCH.CCS[CCWATCH_INTIMIDATION].MONITOR = true

-- Paladin
CCWATCH.CCS[CCWATCH_HOJ] = {}
CCWATCH.CCS[CCWATCH_HOJ].GROUP = 1
CCWATCH.CCS[CCWATCH_HOJ].LENGTH = 3
 -- 4 5 6
CCWATCH.CCS[CCWATCH_HOJ].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_HOJ].TARGET = ""
CCWATCH.CCS[CCWATCH_HOJ].PLAYER = nil
CCWATCH.CCS[CCWATCH_HOJ].TIMER_START = 0
CCWATCH.CCS[CCWATCH_HOJ].TIMER_END = 0
CCWATCH.CCS[CCWATCH_HOJ].DIMINISH = 1
CCWATCH.CCS[CCWATCH_HOJ].MONITOR = true


CCWATCH.CCS[CCWATCH_REPENTANCE] = {}
CCWATCH.CCS[CCWATCH_REPENTANCE].GROUP = 2
CCWATCH.CCS[CCWATCH_REPENTANCE].LENGTH = 6
 -- 4 5 6
CCWATCH.CCS[CCWATCH_REPENTANCE].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_REPENTANCE].TARGET = ""
CCWATCH.CCS[CCWATCH_REPENTANCE].PLAYER = nil
CCWATCH.CCS[CCWATCH_REPENTANCE].TIMER_START = 0
CCWATCH.CCS[CCWATCH_REPENTANCE].TIMER_END = 0
CCWATCH.CCS[CCWATCH_REPENTANCE].DIMINISH = 1
CCWATCH.CCS[CCWATCH_REPENTANCE].MONITOR = true


CCWATCH.CCS[CCWATCH_TURNUNDEAD] = {}
CCWATCH.CCS[CCWATCH_TURNUNDEAD].GROUP = 3
CCWATCH.CCS[CCWATCH_TURNUNDEAD].LENGTH = 10
 -- 15 20
CCWATCH.CCS[CCWATCH_TURNUNDEAD].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_TURNUNDEAD].TARGET = ""
CCWATCH.CCS[CCWATCH_TURNUNDEAD].PLAYER = nil
CCWATCH.CCS[CCWATCH_TURNUNDEAD].TIMER_START = 0
CCWATCH.CCS[CCWATCH_TURNUNDEAD].TIMER_END = 0
CCWATCH.CCS[CCWATCH_TURNUNDEAD].DIMINISH = 1
CCWATCH.CCS[CCWATCH_TURNUNDEAD].MONITOR = true


-- Warlock
CCWATCH.CCS[CCWATCH_SEDUCE] = {}
CCWATCH.CCS[CCWATCH_SEDUCE].GROUP = 5
CCWATCH.CCS[CCWATCH_SEDUCE].LENGTH = 15
CCWATCH.CCS[CCWATCH_SEDUCE].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_SEDUCE].TARGET = ""
CCWATCH.CCS[CCWATCH_SEDUCE].PLAYER = nil
CCWATCH.CCS[CCWATCH_SEDUCE].TIMER_START = 0
CCWATCH.CCS[CCWATCH_SEDUCE].TIMER_END = 0
CCWATCH.CCS[CCWATCH_SEDUCE].DIMINISH = 1
CCWATCH.CCS[CCWATCH_SEDUCE].MONITOR = true


CCWATCH.CCS[CCWATCH_FEAR] = {}
CCWATCH.CCS[CCWATCH_FEAR].GROUP = 3
CCWATCH.CCS[CCWATCH_FEAR].LENGTH = 10
-- 15 20 
CCWATCH.CCS[CCWATCH_FEAR].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_FEAR].TARGET = ""
CCWATCH.CCS[CCWATCH_FEAR].PLAYER = nil
CCWATCH.CCS[CCWATCH_FEAR].TIMER_START = 0
CCWATCH.CCS[CCWATCH_FEAR].TIMER_END = 0
CCWATCH.CCS[CCWATCH_FEAR].DIMINISH = 1
CCWATCH.CCS[CCWATCH_FEAR].MONITOR = true


CCWATCH.CCS[CCWATCH_HOWLOFTERROR] = {}
CCWATCH.CCS[CCWATCH_HOWLOFTERROR].GROUP = 1
CCWATCH.CCS[CCWATCH_HOWLOFTERROR].LENGTH = 10
-- 15
CCWATCH.CCS[CCWATCH_HOWLOFTERROR].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_HOWLOFTERROR].TARGET = ""
CCWATCH.CCS[CCWATCH_HOWLOFTERROR].PLAYER = nil
CCWATCH.CCS[CCWATCH_HOWLOFTERROR].TIMER_START = 0
CCWATCH.CCS[CCWATCH_HOWLOFTERROR].TIMER_END = 0
CCWATCH.CCS[CCWATCH_HOWLOFTERROR].DIMINISH = 1
CCWATCH.CCS[CCWATCH_HOWLOFTERROR].MONITOR = true


CCWATCH.CCS[CCWATCH_DEATHCOIL] = {}
CCWATCH.CCS[CCWATCH_DEATHCOIL].GROUP = 2
CCWATCH.CCS[CCWATCH_DEATHCOIL].LENGTH = 3
CCWATCH.CCS[CCWATCH_DEATHCOIL].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_DEATHCOIL].TARGET = ""
CCWATCH.CCS[CCWATCH_DEATHCOIL].PLAYER = nil
CCWATCH.CCS[CCWATCH_DEATHCOIL].TIMER_START = 0
CCWATCH.CCS[CCWATCH_DEATHCOIL].TIMER_END = 0
CCWATCH.CCS[CCWATCH_DEATHCOIL].DIMINISH = 1
CCWATCH.CCS[CCWATCH_DEATHCOIL].MONITOR = true


CCWATCH.CCS[CCWATCH_BANISH] = {}
CCWATCH.CCS[CCWATCH_BANISH].GROUP = 4
CCWATCH.CCS[CCWATCH_BANISH].LENGTH = 20
-- 30
CCWATCH.CCS[CCWATCH_BANISH].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_BANISH].TARGET = ""
CCWATCH.CCS[CCWATCH_BANISH].PLAYER = nil
CCWATCH.CCS[CCWATCH_BANISH].TIMER_START = 0
CCWATCH.CCS[CCWATCH_BANISH].TIMER_END = 0
CCWATCH.CCS[CCWATCH_BANISH].DIMINISH = 1
CCWATCH.CCS[CCWATCH_BANISH].MONITOR = true


-- Tauren
CCWATCH.CCS[CCWATCH_WARSTOMP] = {}
CCWATCH.CCS[CCWATCH_WARSTOMP].GROUP = 3
CCWATCH.CCS[CCWATCH_WARSTOMP].LENGTH = 2
CCWATCH.CCS[CCWATCH_WARSTOMP].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_WARSTOMP].TARGET = ""
CCWATCH.CCS[CCWATCH_WARSTOMP].PLAYER = nil
CCWATCH.CCS[CCWATCH_WARSTOMP].TIMER_START = 0
CCWATCH.CCS[CCWATCH_WARSTOMP].TIMER_END = 0
CCWATCH.CCS[CCWATCH_WARSTOMP].DIMINISH = 1
CCWATCH.CCS[CCWATCH_WARSTOMP].MONITOR = true


-- Warrior
CCWATCH.CCS[CCWATCH_INTERCEPT] = {}
CCWATCH.CCS[CCWATCH_INTERCEPT].GROUP = 1
CCWATCH.CCS[CCWATCH_INTERCEPT].LENGTH = 3
CCWATCH.CCS[CCWATCH_INTERCEPT].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_INTERCEPT].TARGET = ""
CCWATCH.CCS[CCWATCH_INTERCEPT].PLAYER = nil
CCWATCH.CCS[CCWATCH_INTERCEPT].TIMER_START = 0
CCWATCH.CCS[CCWATCH_INTERCEPT].TIMER_END = 0
CCWATCH.CCS[CCWATCH_INTERCEPT].DIMINISH = 1
CCWATCH.CCS[CCWATCH_INTERCEPT].MONITOR = true


CCWATCH.CCS[CCWATCH_MACESPE] = {}
CCWATCH.CCS[CCWATCH_MACESPE].GROUP = 1
CCWATCH.CCS[CCWATCH_MACESPE].LENGTH = 3
CCWATCH.CCS[CCWATCH_MACESPE].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_MACESPE].TARGET = ""
CCWATCH.CCS[CCWATCH_MACESPE].PLAYER = nil
CCWATCH.CCS[CCWATCH_MACESPE].TIMER_START = 0
CCWATCH.CCS[CCWATCH_MACESPE].TIMER_END = 0
CCWATCH.CCS[CCWATCH_MACESPE].DIMINISH = 1
CCWATCH.CCS[CCWATCH_MACESPE].MONITOR = true


CCWATCH.CCS[CCWATCH_IMPHAMSTRING] = {}
CCWATCH.CCS[CCWATCH_IMPHAMSTRING].GROUP = 2
CCWATCH.CCS[CCWATCH_IMPHAMSTRING].LENGTH = 3
CCWATCH.CCS[CCWATCH_IMPHAMSTRING].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_IMPHAMSTRING].TARGET = ""
CCWATCH.CCS[CCWATCH_IMPHAMSTRING].PLAYER = nil
CCWATCH.CCS[CCWATCH_IMPHAMSTRING].TIMER_START = 0
CCWATCH.CCS[CCWATCH_IMPHAMSTRING].TIMER_END = 0
CCWATCH.CCS[CCWATCH_IMPHAMSTRING].DIMINISH = 1
CCWATCH.CCS[CCWATCH_IMPHAMSTRING].MONITOR = true


CCWATCH.CCS[CCWATCH_INTIMIDATINGSHOUT] = {}
CCWATCH.CCS[CCWATCH_INTIMIDATINGSHOUT].GROUP = 3
CCWATCH.CCS[CCWATCH_INTIMIDATINGSHOUT].LENGTH = 8
CCWATCH.CCS[CCWATCH_INTIMIDATINGSHOUT].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_INTIMIDATINGSHOUT].TARGET = ""
CCWATCH.CCS[CCWATCH_INTIMIDATINGSHOUT].PLAYER = nil
CCWATCH.CCS[CCWATCH_INTIMIDATINGSHOUT].TIMER_START = 0
CCWATCH.CCS[CCWATCH_INTIMIDATINGSHOUT].TIMER_END = 0
CCWATCH.CCS[CCWATCH_INTIMIDATINGSHOUT].DIMINISH = 1
CCWATCH.CCS[CCWATCH_INTIMIDATINGSHOUT].MONITOR = true


CCWATCH.CCS[CCWATCH_IMPREVENGE] = {}
CCWATCH.CCS[CCWATCH_IMPREVENGE].GROUP = 1
CCWATCH.CCS[CCWATCH_IMPREVENGE].LENGTH = 3
CCWATCH.CCS[CCWATCH_IMPREVENGE].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_IMPREVENGE].TARGET = ""
CCWATCH.CCS[CCWATCH_IMPREVENGE].PLAYER = nil
CCWATCH.CCS[CCWATCH_IMPREVENGE].TIMER_START = 0
CCWATCH.CCS[CCWATCH_IMPREVENGE].TIMER_END = 0
CCWATCH.CCS[CCWATCH_IMPREVENGE].DIMINISH = 1
CCWATCH.CCS[CCWATCH_IMPREVENGE].MONITOR = true


CCWATCH.CCS[CCWATCH_CONCUSSIONBLOW] = {}
CCWATCH.CCS[CCWATCH_CONCUSSIONBLOW].GROUP = 1
CCWATCH.CCS[CCWATCH_CONCUSSIONBLOW].LENGTH = 5
CCWATCH.CCS[CCWATCH_CONCUSSIONBLOW].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_CONCUSSIONBLOW].TARGET = ""
CCWATCH.CCS[CCWATCH_CONCUSSIONBLOW].PLAYER = nil
CCWATCH.CCS[CCWATCH_CONCUSSIONBLOW].TIMER_START = 0
CCWATCH.CCS[CCWATCH_CONCUSSIONBLOW].TIMER_END = 0
CCWATCH.CCS[CCWATCH_CONCUSSIONBLOW].DIMINISH = 1
CCWATCH.CCS[CCWATCH_CONCUSSIONBLOW].MONITOR = true


-- Specific

-- Green Whelp Armour
CCWATCH.CCS[CCWATCH_SLEEP] = {}
CCWATCH.CCS[CCWATCH_SLEEP].GROUP = 3
CCWATCH.CCS[CCWATCH_SLEEP].LENGTH = 30
CCWATCH.CCS[CCWATCH_SLEEP].DIMINISHES = 2

CCWATCH.CCS[CCWATCH_SLEEP].TARGET = ""
CCWATCH.CCS[CCWATCH_SLEEP].PLAYER = nil
CCWATCH.CCS[CCWATCH_SLEEP].TIMER_START = 0
CCWATCH.CCS[CCWATCH_SLEEP].TIMER_END = 0
CCWATCH.CCS[CCWATCH_SLEEP].DIMINISH = 1
CCWATCH.CCS[CCWATCH_SLEEP].MONITOR = true


end